// Fill out your copyright notice in the Description page of Project Settings.

#include "ShooterTutorial.h"
#include "ShooterFunctions.h"

bool UShooterFunctions::ChangeSoundClassVolume(USoundClass * SoundClass, float NewVolume)
{
	if (SoundClass)
	{
		SoundClass->Properties.Volume = NewVolume;
		return true;
    }
	return false;
}

bool UShooterFunctions::IncreaseFloatByName(UObject * Target, FName VarName, float ValueToAdd, float &outFloat)
{
	if (Target)
	{
		float FoundFloat, IncreasedFloat;
		UFloatProperty* FloatProp = FindField<UFloatProperty>(Target->GetClass(), VarName);
		{
			if (FloatProp)
			{
				FoundFloat = FloatProp->GetPropertyValue_InContainer(Target);
				IncreasedFloat = FoundFloat + ValueToAdd;  //increase the value 
				FloatProp->SetPropertyValue_InContainer(Target, IncreasedFloat); //and then set it
				outFloat = IncreasedFloat;
				return true;
			}
		}
	}
	return false;
}

bool UShooterFunctions::SetFloatByName(UObject * Target, FName VarName, float NewValue, float & outFloat)
{
	if (Target)
	{
		float FoundFloat;
		UFloatProperty* FloatProp = FindField<UFloatProperty>(Target->GetClass(), VarName);
		if (FloatProp)
		{
			FloatProp->SetPropertyValue_InContainer(Target, NewValue);
			FoundFloat = FloatProp->GetPropertyValue_InContainer(Target);
			outFloat = FoundFloat;
			return true;
		}
	}
	return false;
}

bool UShooterFunctions::SetIntByName(UObject * Target, FName VarName, int32 NewValue, int32 & outInt)
{
	if (Target)
	{
		int32 FoundInt;
		UIntProperty* IntProp = FindField<UIntProperty>(Target->GetClass(), VarName);
		if (IntProp)
		{
			IntProp->SetPropertyValue_InContainer(Target, NewValue);
			FoundInt = IntProp->GetPropertyValue_InContainer(Target);
			outInt = FoundInt;
			return true;
		}
	}
	return false;
}

bool UShooterFunctions::IncreaseIntByName(UObject * Target, FName VarName, int32 ValueToAdd, int32 &outInt)
{
	if (Target)
	{
		int32 FoundInt, IncreasedInt;
		UIntProperty* IntProp = FindField<UIntProperty>(Target->GetClass(), VarName);
		if (IntProp)
		{
			FoundInt = IntProp->GetPropertyValue_InContainer(Target);
			IncreasedInt = FoundInt + ValueToAdd;
			IntProp->SetPropertyValue_InContainer(Target, IncreasedInt);
			outInt = IncreasedInt;
			return true;
		}
	}
	return false;
}

bool UShooterFunctions::GetFloatByName(UObject * Target, FName VarName, float & outFloat)
{
	if (Target) //make sure Target was set in blueprints. 
	{
		float FoundFloat;
		UFloatProperty* FloatProp = FindField<UFloatProperty>(Target->GetClass(), VarName);  // try to find float property in Target named VarName
		if (FloatProp) //if we found variable
		{
			FoundFloat = FloatProp->GetPropertyValue_InContainer(Target);  // get the value from FloatProp
			outFloat = FoundFloat;  // return float
			return true; // we can return
		}
	}
	return false; // we haven't found variable return false
}

bool UShooterFunctions::GetIntByName(UObject * Target, FName VarName, int32 & outInt)
{
	if (Target)
	{
		int32 FoundInt;
		UIntProperty* IntProp = FindField<UIntProperty>(Target->GetClass(), VarName);  //this time I'm using UIntProperty as I'm searching for int
		if (IntProp)
		{
			FoundInt = IntProp->GetPropertyValue_InContainer(Target);
			outInt = FoundInt;
			return true;
		}
	}
	return false;
}
